<template>
  <div class="superuser-card grid gap-6 items-center p-4">
    <div class="flex items-center justify-between xs:w-full">
      <div class="flex items-center gap-4">
        <p class="text-lg leading-5 font-bold text-txtdprim">
          {{ index + 1 + '.' }}
        </p>
        <p class="text-lg leading-5 font-bold text-txtdprim w-full overflow-hidden overflow-ellipsis whitespace-nowrap">
          {{ user.email ? user.email : 'Email not set' }}
        </p>
      </div>
    </div>
    <div class="flex items-center gap-4 xs:hidden">
      <div style="height: 45px" class="w-0.5 bg-brdddef"></div>
      <div class="w-full">
        <p class="text-sm font-medium text-txtdtert">Public Address</p>
        <p
          class="leading-5 font-bold text-txtdprim capitalize whitespace-nowrap overflow-hidden overflow-ellipsis w-full"
        >
          {{ user.public_address }}
        </p>
      </div>
    </div>
    <div class="flex items-center gap-5">
      <UiButton button-height="sm" class="rounded-16 w-24 ml-auto" @click="deleteUser">
        <span v-if="!loading">Delete</span> <LoadingSpinner color-type="white" v-else />
      </UiButton>
    </div>
  </div>
</template>

<script lang="ts">
import { deleteSuperUser } from '@/api/admin';

import LoadingSpinner from '@/components/ui/LoadingSpinner.vue';
import UiButton from '@/components/ui/UiButton.vue';

export default {
  name: 'UserCard',

  components: { UiButton, LoadingSpinner },

  props: {
    user: {
      type: Object,
      default: () => ({}),
    },

    index: {
      type: Number,
      default: 1,
    },
  },

  data() {
    return {
      loading: false,
    };
  },

  methods: {
    async deleteUser() {
      this.loading = true;

      try {
        await deleteSuperUser(this.user.public_address);
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'User successfully deleted.',
        });
        this.$emit('update-users');
      } catch (err) {
        console.error(err);
        this.$store.dispatch('setPopupDisplay', {
          display: true,
          text: 'Error while deleting user.',
        });
      } finally {
        this.loading = false;
      }
    },
  },
};
</script>

<style lang="scss">
.superuser-card {
  grid-template-columns: 300px max-content 1fr;
}
</style>
